#include "testlib.h"
#include <iostream>

using namespace std;

string genStr(int n, int cnt);

string genPalindrome(int n, int cnt) {
    auto res = genStr(n / 2, cnt);
    auto s = res;
    reverse(s.begin(), s.end());
    if (n & 1) {
        res += genStr(1, cnt);
    }
    res += s;
    return res;
}

string genStr(int n, int cnt) {
    if (n == 0) {
        return "";
    } else if (n == 1) {
        return ""s + (char)rnd.next('a', 'a' + cnt - 1);
    } else {
        int leftSize = rnd.next(1, n - 1);
        return genPalindrome(leftSize, cnt) + genPalindrome(n - leftSize, cnt);
    }
}

int main(int argc, char* argv[]) {
    registerGen(argc, argv, 1);

    int n = atoi(argv[1]);
    println(n);
    int cnt = atoi(argv[2]);

    println(genStr(n, cnt));
    return 0;
}
