#include "testlib.h"
#include <iostream>

using namespace std;

string genPalindrome(int n, int cnt) {
    auto s = rnd.next("[a-"s + char('a' + cnt - 1) + "]{" + to_string((n + 1) / 2) + "}");
    auto r = s;
    if (n & 1) r.pop_back();
    reverse(r.begin(), r.end());
    return s + r;
}

int main(int argc, char* argv[]) {
    registerGen(argc, argv, 1);

    int n = atoi(argv[1]);
    println(n);
    int len = atoi(argv[2]);
    int cnt = atoi(argv[3]);

    auto s = genPalindrome(len, cnt);
    string r;
    while (r.size() < n) {
        r += s;
    }
    r.resize(n);
    println(r);
    return 0;
}
