#include "testlib.h"
#include <iostream>

using namespace std;

string inverse(string s, char a, char b) {
    for (char &c : s) {
        if (c == a) {
            c = b;
        } else {
            c = a;
        }
    }
    return s;
}

int main(int argc, char* argv[]) {
    registerGen(argc, argv, 1);

    int n = atoi(argv[1]);
    println(n);

    char a = rnd.next(26) + 'a';
    char b = rnd.next(25) + 'a';
    if (a == b) ++b;

    string s;
    s = a;
    while (s.size() < n) {
        s += inverse(s, a, b);
    }

    s.resize(n);
    println(s);

    return 0;
}
