// Created by Nikolay Budin

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;

using namespace __gnu_pbds;
template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename K, typename V> using ordered_map = tree<K, V, less<K>, rb_tree_tag, tree_order_statistics_node_update>;

int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;
#ifdef LOCAL
	mt19937 tw(9450189);
#else
	mt19937 tw(chrono::high_resolution_clock::now().time_since_epoch().count());
#endif
uniform_int_distribution<ll> ll_distr;
ll rnd(ll a, ll b) { return ll_distr(tw) % (b - a + 1) + a; }


void solve() {
	int n;
	cin >> n;
	string s;
	cin >> s;
	string t;
	for (char c : s) {
		t += c;
		t += '.';
	}
	t.pop_back();
	vector<int> sz(szof(t));
	int center = -1, r = 0;
	vector<ordered_set<pii>> by_r(4);
	vector<set<pii>> by_pos(4);
	ll ans = 0;
	// cerr << t << endl;
	for (int i = 0; i < szof(t); ++i) {
		if (i < center + r) {
			sz[i] = min(center + r - i, sz[center * 2 - i]);
		}
		while (i - sz[i] >= 0 && i + sz[i] < szof(t) && t[i - sz[i]] == t[i + sz[i]]) {
			++sz[i];
		}
		if (i + sz[i] > r + center) {
			center = i;
			r = sz[i];
		}

		int t = i % 4;
		int other = t;
		if (i % 2 == 0) {
			other ^= 2;
		}
		auto& cur_by_r = by_r[other];
		auto& cur_by_pos = by_pos[other];
		while (szof(cur_by_pos) && cur_by_pos.begin()->ff < i) {
			auto it = cur_by_pos.begin();
			cur_by_r.erase({it->ss, it->ff});
			cur_by_pos.erase(it);
		}
		ans += szof(cur_by_r) - cur_by_r.order_of_key({i - sz[i] * 2, -1});
		by_r[t].insert({i, i + sz[i] * 2});
		by_pos[t].insert({i + sz[i] * 2, i});
		// cerr << i << " " << ans << endl;
	}

	cout << ans << "\n";
}


int main() {
#ifdef LOCAL
	auto start_time = clock();
	cerr << setprecision(3) << fixed;
#endif
	cout << setprecision(15) << fixed;
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int test_count = 1;
	// cin >> test_count;
	for (int test = 1; test <= test_count; ++test) {
		solve();
	}

#ifdef LOCAL
	auto end_time = clock();
	cerr << "Execution time: " << (end_time - start_time) * (int)1e3 / CLOCKS_PER_SEC << " ms\n";
#endif
}
